#if !defined(__SANGWUG_KERNEL_MATH_MATH_CONSTANT_H_)
#define __SANGWUG_KERNEL_MATH_MATH_CONSTANT_H_ 1


//-----------------------------------------------------------------------------------------
//  struct swMathConst

struct swMathConst
{
/**@name Public Data Members */
//@{
public :
	///  axis & plane
	enum EAxis { AXIS_NULL = 0x0, AXIS_X = 0x1, AXIS_Y = 0x2, AXIS_Z = 0x4 };
	enum EPlane { PLANE_NULL = 0x0, PLANE_XY = 0x1, PLANE_YZ = 0x2, PLANE_ZX = 0x4, PLANE_NORMAL = 0x8 };

	///  constant
	static const double INF;
	static const double NaN;

	static const double PI;
	static const double _2_PI;
	static const double _4_PI;
	static const double PI_2;
	static const double PI_3;
	static const double PI_4;
	static const double PI_6;

	static const double E;

	static const double TO_RAD;
	static const double TO_DEG;

	///  non-constant
	static double EPS;

	static int IterationLimit;
//@}
};


#endif  //  __SANGWUG_KERNEL_MATH_MATH_CONSTANT_H_
