#if !defined(_UNIFORMLY_ACCELERATED_MOTION_HEADER_)
#define _UNIFORMLY_ACCELERATED_MOTION_HEADER_


//  ӵ 
class CUniformlyAcceleratedMotion
{
public:
	CUniformlyAcceleratedMotion(double Ax, double Ay, double Vx0 = 0.0, double Vy0 = 0.0, double x0 = 0.0, double y0 = 0.0)
	: Ax_(Ax), Ay_(Ay), Az_(0.0), Vx0_(Vx0), Vy0_(Vy0), Vz0_(0.0), x0_(x0), y0_(y0), z0_(0.0)
	{}
	CUniformlyAcceleratedMotion(double Ax, double Ay, double Az, double Vx0 = 0.0, double Vy0 = 0.0, double Vz0 = 0.0, double x0 = 0.0, double y0 = 0.0, double z0 = 0.0)
	: Ax_(Ax), Ay_(Ay), Az_(Az), Vx0_(Vx0), Vy0_(Vy0), Vz0_(Vz0), x0_(x0), y0_(y0), z0_(z0)
	{}
	~CUniformlyAcceleratedMotion()  {}

	//  ð t  ġ
	double getX(double t) const;
	double getY(double t) const;
	double getZ(double t) const;

	//  ð t  ӵ
	double getVx(double t) const;
	double getVy(double t) const;
	double getVz(double t) const;

	//  ð t  ӵ
	double getAx(double) const;
	double getAy(double) const;
	double getAz(double) const;

protected:
	const double Ax_, Ay_, Az_;
	const double Vx0_, Vy0_, Vz0_;
	const double x0_, y0_, z0_;
};


#endif  //  _UNIFORMLY_ACCELERATED_MOTION_HEADER_
