#include "Matrix.h"
#include <cmath>
#include <memory.h>


CMatrix3::CMatrix3()
{
	//    ǹ̸ 
	//for (int i = 0; i < 9; ++i) element[i] = 0.0;
	::memset(element, '\0', sizeof(element));
}

CMatrix3::CMatrix3(const double rhs[9])
{
	//    ǹ̸ 
	//for (int i = 0; i < 9; ++i) element[i] = rhs[i];
	::memcpy(element, rhs, sizeof(element));
}

CMatrix3::CMatrix3(const CMatrix3& rhs)
{
	//    ǹ̸ 
	//for (int i = 0; i < 9; ++i) element[i] = rhs.element[i];
	::memcpy(element, rhs.element, sizeof(element));
}

CMatrix3& CMatrix3::operator=(const CMatrix3& rhs)
{
	if (this == &rhs) return *this;
	::memcpy(element, rhs.element, sizeof(element));
	return *this;
}

void CMatrix3::Identity()
{
	//  [ 2-6] 
	element[0] = 1.0;
	element[1] = 0.0;
	element[2] = 0.0;

	element[3] = 0.0;
	element[4] = 1.0;
	element[5] = 0.0;

	element[6] = 0.0;
	element[7] = 0.0;
	element[8] = 1.0;
}

void CMatrix3::Transpose()
{
	//  [ 2-8] ġ
	CMatrix3 mat(*this);
	for (int i = 0; i < 3; ++i)
		for (int j = 0; j < 3; ++j)
			element[j*3 + i] = mat.element[i*3 + j];
}

CMatrix3& CMatrix3::operator+()
{  return *this;  }

CMatrix3 CMatrix3::operator-() const
{
	CMatrix3 mat(*this);
	mat.Scalar(-1.0);
	return mat;
}

CMatrix3 CMatrix3::operator+(const CMatrix3& rhs) const
{
	//  [ 2-11]  
	CMatrix3 mat(*this);
	for (int i = 0; i < 9; ++i)
		mat.element[i] += rhs.element[i];
	return mat;
}

CMatrix3& CMatrix3::operator+=(const CMatrix3& rhs)
{
	//  [ 2-11]  
	for (int i = 0; i < 9; ++i)
		element[i] += rhs.element[i];
	return *this;
}

CMatrix3 CMatrix3::operator-(const CMatrix3& rhs) const
{
	//  [ 2-13]  
	CMatrix3 mat(*this);
	for (int i = 0; i < 9; ++i)
		mat.element[i] -= rhs.element[i];
	return mat;
}

CMatrix3& CMatrix3::operator-=(const CMatrix3& rhs)
{
	//  [ 2-13]  
	for (int i = 0; i < 9; ++i)
		element[i] -= rhs.element[i];
	return *this;
}

CMatrix3 CMatrix3::operator*(const CMatrix3& rhs) const
{
	//  [ 2-15]  
	CMatrix3 mat;
	for (int i = 0; i < 3; ++i)
		for (int j = 0; j < 3; ++j)
			for (int k = 0; k < 3; ++k)
				mat.element[j*3 + i] += element[k*3 + i] * rhs.element[j*3 + k];
	return mat;
}

CMatrix3& CMatrix3::operator*=(const CMatrix3& rhs)
{
	//  [ 2-15]  
	return (*this = *this * rhs);
}

void CMatrix3::Scalar(double k)
{
	//  [ 2-17] İ Į 
	for (int i = 0; i < 9; ++i)
		element[i] *= k;
}

double CMatrix3::Det() const
{
	//  [ 2-22] 3 Ľ
	double det = 0.0;
	det = element[0] * element[4] * element[8] + element[3] * element[7] * element[2] + element[6] * element[1] * element[5];
	det -= element[0] * element[7] * element[5] + element[3] * element[1] * element[8] + element[6] * element[4] * element[2];
	return det;
}

CMatrix3 CMatrix3::Inverse() const
{
	//  [ 2-29] 
	double det = Det();

	//  Ľ 0̸   ʴ´(Ư 쿡 ش)
	if (fabs(det) < 1.0e-5)
		return CMatrix3();

	CMatrix3 adjoint(Adjoint());
	adjoint.Scalar(1.0 / det);
	return adjoint;
}

CMatrix3 CMatrix3::Adjoint() const
{
	//  [ 2-28] 
	CMatrix3 adjoint;
	adjoint.element[0] = element[4] * element[8] - element[7] * element[5];
	adjoint.element[1] = -element[1] * element[8] + element[7] * element[2];
	adjoint.element[2] = element[1] * element[5] - element[4] * element[2];

	adjoint.element[3] = -element[3] * element[8] + element[6] * element[5];
	adjoint.element[4] = element[0] * element[8] - element[6] * element[2];
	adjoint.element[5] = -element[0] * element[5] + element[3] * element[2];

	adjoint.element[6] = element[3] * element[7] - element[6] * element[4];
	adjoint.element[7] = -element[0] * element[7] + element[6] * element[1];
	adjoint.element[8] = element[0] * element[4] - element[3] * element[1];
	return adjoint;
}
